LeetCode #752 Open the Lock

Medium

Len Chen
2 min readSep 23, 2018

Problem

You have a lock in front of you with 4 circular wheels. Each wheel has 10 slots: '0', '1', '2', '3', '4', '5', '6', '7', '8', '9'. The wheels can rotate freely and wrap around: for example we can turn '9' to be '0', or '0' to be '9'. Each move consists of turning one wheel one slot.

The lock initially starts at '0000', a string representing the state of the 4 wheels.

You are given a list of deadends dead ends, meaning if the lock displays any of these codes, the wheels of the lock will stop turning and you will be unable to open it.

Given a target representing the value of the wheels that will unlock the lock, return the minimum total number of turns required to open the lock, or -1 if it is impossible.

Example 1:

Input: deadends = ["0201","0101","0102","1212","2002"], target = "0202"
Output: 6
Explanation:
A sequence of valid moves would be "0000" -> "1000" -> "1100" -> "1200" -> "1201" -> "1202" -> "0202".
Note that a sequence like "0000" -> "0001" -> "0002" -> "0102" -> "0202" would be invalid,
because the wheels of the lock become stuck after the display becomes the dead end "0102".

Example 2:

Input: deadends = ["8888"], target = "0009"
Output: 1
Explanation:
We can turn the last wheel in reverse to move from "0000" -> "0009".

Example 3:

Input: deadends = ["8887","8889","8878","8898","8788","8988","7888","9888"], target = "8888"
Output: -1
Explanation:
We can't reach the target without getting stuck.

Example 4:

Input: deadends = ["0000"], target = "8888"
Output: -1

Note:

  1. The length of deadends will be in the range [1, 500].
  2. target will not be in the list deadends.
  3. Every string in deadends and the string target will be a string of 4 digits from the 10,000 possibilities '0000' to '9999'.

Solution — Single Side BFS

Because we can only change one digit to its next/previous number, this problem should be resolve by BFS approach. It’s noted that visited number should be saved into deadends or it will be visited again. Unfortunately, this approach will reach time limit in LeetCode.

Complexity

Because we know all candidates will be visited after at most 10000 iterations, so time complexity is O(10000) = O(1) actually. But if counts of digits increase from 4 to n, its time complexity will become O(10^n).

For space complexity, because there are two directions for rotating digits and there are 4 digits in this lock, the queue should support up to 8 element in it. Therefore, space complexity is O(2*4) = O(8) = O(1). And again, if counts of digits increase from 4 to n, its space complexity will become O(2*n) = O(n).

Solution — Double Side BFS

Instead of starting only from “0000”, we start from both “0000” and target and search their neighbors interactively. Once one number entering a another one’s visited number, the shortest steps between these two ends is found.

Complexity

The time complexity and space complexity are both double of single side approach but still O(1)/O(10^n) and O(1)/O(n) correspondingly.

--

--

Len Chen
Len Chen

No responses yet